﻿using System.Collections.Generic;
using Luticate2.Auth.Business;
using Luticate2.Auth.DataAccess;
using Luticate2.Auth.Middlewares;
using Luticate2.Utils.Controllers;
using Luticate2.Utils.Dbo.OrderBy;
using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.DependencyInjection;

namespace Luticate2.Auth.Controllers
{
    public static class LuticateExtensions
    {
        public static IServiceCollection AddLuticate(this IServiceCollection services)
        {
            services.AddSingleton<LuGroupsController>();
            services.AddSingleton<LuGroupsBusiness>();
            services.AddSingleton<LuGroupsDataAccess>();

            services.AddSingleton<LuUsersController>();

            services.AddDbContext<LuDatabaseContext>();

            return services;
        }

        public static IMvcBuilder AddLuticate(this IMvcBuilder builder)
        {
//            builder.AddApplicationPart(typeof(LuController).GetTypeInfo().Assembly)
//                .AddControllersAsServices();
            builder.Services.Configure<MvcOptions>(
                options => options.ModelBinderProviders.Insert(0, new LuOrderByBinderProvider()));
            return builder;
        }

        public static IApplicationBuilder UseLuticate(this IApplicationBuilder app)
        {
            app.UseMiddleware<LuAuthMiddleware>();
            return app;
        }

        public static object GetLuCurrentUser(this HttpContext context)
        {
            return context.GetLuItems()["currentUser"];//TODO
        }
    }
}